#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

template<class T, class U>
inline ostream &operator<<(ostream &out, const pair<T, U> &p)
{
    out << p.first << ' ' << p.second;
    return out;
}

template<class T, class U>
inline istream &operator<<(istream &in, const pair<T, U> &p)
{
    in >> p.first >> p.second;
    return in;
}

template<class T>
inline istream &operator>>(istream &in, vector<T> &v)
{
    for(auto &i : v)
        in >> i;
    return in;
}

template<class T>
inline ostream &operator>>(ostream &out, const vector<T> &v)
{
    if(v.empty())
        return out;

    out << v.front();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

void _pre()
{
#ifdef ANDREIKKAA
    assert(freopen("input.txt", "r", stdin) != nullptr);
    //freopen("output.txt", "w", stdout);
#endif // ANDREIKKA
}

void _post()
{
#ifdef ANDREIKKAA

#endif // ANDREIKKAA
}

void _solve()
{
    int n, m, k;
    cin >> n >> m >> k;
    string s, t;
    cin >> s >> t;
    map<string, int> v;
    for(int i = 0; i < m - n + 1; ++i)
    {
        ++v[t.substr(i, n)];
    }
    int ans = 0;
    for(auto i : v)
    {
        int cnt = 0;
        for(int j = 0;  j< n; ++j)
        {
            cnt += i.first[j] != s[j];
        }
        if(cnt <= k)
            ans = max(ans, i.second);
    }
    cout << ans << endl;
}

int main()
{
    _pre();
    _solve();
    _post();
    return 0;
}
