#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

template<class T, class U>
inline ostream &operator<<(ostream &out, const pair<T, U> &p)
{
    out << p.first << ' ' << p.second;
    return out;
}

template<class T, class U>
inline istream &operator>>(istream &in, pair<T, U> &p)
{
    in >> p.first >> p.second;
    return in;
}

template<class T>
inline istream &operator>>(istream &in, vector<T> &v)
{
    for(auto &i : v)
        in >> i;
    return in;
}

template<class T>
inline ostream &operator>>(ostream &out, const vector<T> &v)
{
    if(v.empty())
        return out;

    out << v.front();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

void _pre()
{
#ifdef ANDREIKKAA
    assert(freopen("input.txt", "r", stdin) != nullptr);
    //freopen("output.txt", "w", stdout);
#endif // ANDREIKKA
}

void _post()
{
#ifdef ANDREIKKAA

#endif // ANDREIKKAA
}

vector<ll> prf;
int go(ll t, vector<pair<ll, ll>> &rgt)
{
    int l = 0;
    int r = rgt.size();
    while(l != r)
    {
        int m = (l + r) / 2;
        if(rgt[m].first <= t)
        {
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }
    return prf[l];
}

int ss(vector<pair<ll, ll>> lft, vector<pair<ll, ll>> rgt)
{
    prf.clear();
    prf.resize(rgt.size() + 1);
    if(!rgt.empty())
    {
        for(int i = 1; i <= rgt.size(); ++i)
        {
            prf[i] = prf[i - 1];
            if(rgt[i - 1].second - rgt[i - 1].first > 0)
                ++prf[i];
        }
    }

    int ans = 0;
    ll tim = 1228228228;
    ans = max(ans, go(tim, rgt));
    for(int i = 0; i < lft.size(); ++i)
    {
        tim = min(tim, lft[i].second - lft[i].first);
        if(tim <= 0)
            break;
        ans = max(ans, go((tim - 1) / 2, rgt) + i + 1);
    }
    return ans;
}

void _solve()
{
    int n;
    cin >> n;

    vector<pair<ll, ll>> v(n);
    cin >> v;

    vector<pair<ll, ll>> lft, rgt;
    int add_ans = 0;
    for(auto i : v)
    {
        if(i.first < 0)
        {
            lft.push_back({-i.first, i.second});
        }
        else if(i.first > 0)
        {
            rgt.push_back({i.first, i.second});
        }
        else if(i.second > 0)
        {
            ++add_ans;
        }
    }
    sort(lft.begin(), lft.end());
    sort(rgt.begin(), rgt.end());

    int ans = max(ss(lft, rgt), ss(rgt, lft));
    //cout << ans << endl;
    cout << max((ans + add_ans) - (ans + add_ans + 1) % 2, 0) << endl;
}

int main()
{
    _pre();
    _solve();
    _post();
    return 0;
}
