#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

template<class T, class U>
inline ostream &operator<<(ostream &out, const pair<T, U> &p)
{
    out << p.first << ' ' << p.second;
    return out;
}

template<class T, class U>
inline istream &operator>>(istream &in, pair<T, U> &p)
{
    in >> p.first >> p.second;
    return in;
}

template<class T>
inline istream &operator>>(istream &in, vector<T> &v)
{
    for(auto &i : v)
        in >> i;
    return in;
}

template<class T>
inline ostream &operator>>(ostream &out, const vector<T> &v)
{
    if(v.empty())
        return out;

    out << v.front();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

void _pre()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef ANDREIKKAA
    assert(freopen("input.txt", "r", stdin) != nullptr);
    //freopen("output.txt", "w", stdout);
#endif // ANDREIKKA
}

void _post()
{
#ifdef ANDREIKKAA

#endif // ANDREIKKAA
}

char MEM[500 * 1000 * 1000];
int PTR = 0;
inline void* operator new(size_t x)
{
    PTR += x;
    return MEM + PTR - x;
}
inline void operator delete(void*) _GLIBCXX_USE_NOEXCEPT
{

}

void _solve()
{
    int n, w, k;
    cin >> n >> w >> k;

    static char a[1001][1001];
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            a[i][j] = 'x';

    for(int i = 0; i < k; ++i)
    {
        for(int j = i + 1; j < n; ++j)
        {
            a[i][j] = '1';
            a[j][i] = '0';
        }
    }

    vector<int> cnt(n);
    set<pair<int, int>> s;
    for(int i = k; i < n; ++i)
    {
        s.insert({0, i});
        cnt[i] = n - k - 1;
    }
    for(int i = (n - k) * (n - k - 1) / 2; i > 0; --i)
    {
        auto x = s.begin();
        auto y = --s.end();
        while(a[x->second][y->second] != 'x')
            --y;
        a[x->second][y->second] = '1';
        a[y->second][x->second] = '0';
        --cnt[x->second];
        --cnt[y->second];
        if(cnt[x->second] != 0)
        {
            s.insert({x->first + 1, x->second});
        }
        s.erase(x);
        if(cnt[y->second] == 0)
        {
            s.erase(y);
        }
    }
    for(int i = 0; i < n; ++i)
    {
        a[i][i] = '0';
        int cnt = 0;
        for(int j = 0; j < n; ++j)
        {
            //assert(a[i][j] != 'x');
            cnt += a[i][j] == '1';
        }
        if(cnt >= w)
            --k;
    }

    if(k != 0)
    {
        puts("NO");
        return;
    }

    puts("YES");
    for(int i = 0; i < n; ++i)
    {
        for(int j = 0; j < n; ++j)
            putchar(a[i][j]);
        putchar('\n');
    }
}

int main()
{
    _pre();
    _solve();
    _post();
    return 0;
}
