#include <iostream>
#include <iomanip>
#include <cstdio>

#include <cassert>
#include <cmath>
#include <algorithm>

#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <bitset>
#include <queue>

using std::cin;
using std::cout;
using std::cerr;

using std::min;
using std::max;
using std::abs;

using std::vector;
using std::pair;
using std::set;
using std::map;
using std::queue;
using std::bitset;
using std::string;

#define ff first
#define ss second
#define pb push_back
#define print(a) cerr << (a) << '\n'
#define dbg(a) cerr << #a << " = " << (a) << '\n'
#define dbg2(a, b) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << '\n'
#define dbg3(a, b, c) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << '\n'
#define dbg4(a, b, c, d) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << '\n'
#define dbg5(a, b, c, d, e) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << ' ' << #e << " = " << (e) << '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void init() {
	std::iostream::sync_with_stdio(0);
	cout << std::fixed << std::setprecision(10);
	cerr << std::fixed << std::setprecision(10);
	srand(time(0));
}

const int MAXN = 1e6 + 1;
int f[MAXN];

int main() {
	init();

    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        f[x] = 1;
    }

    ll cnt = 0;
    ll bt = 0, bb = 100, wb;
    for (ll i = 1; i <= n; ++i) {
        cnt += f[i];
        if (cnt * bb > bt * i) {
            bt = cnt;
            bb = i;
            wb = i;
        }
    }

    for (int i = 1; i <= wb; ++i) cout << "1 ";
    for (int i = wb + 1; i <= n; ++i) cout << "0 ";
    cout << '\n';


	return 0;
}


