#include <iostream>
#include <iomanip>
#include <cstdio>

#include <cassert>
#include <cmath>
#include <algorithm>

#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <bitset>
#include <queue>

using std::cin;
using std::cout;
using std::cerr;

using std::min;
using std::max;
using std::abs;

using std::vector;
using std::pair;
using std::set;
using std::map;
using std::queue;
using std::bitset;
using std::string;

#define ff first
#define ss second
#define pb push_back
#define print(a) cerr << (a) << '\n'
#define dbg(a) cerr << #a << " = " << (a) << '\n'
#define dbg2(a, b) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << '\n'
#define dbg3(a, b, c) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << '\n'
#define dbg4(a, b, c, d) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << '\n'
#define dbg5(a, b, c, d, e) cerr << #a << " = " << (a) << ' ' << #b << " = " << (b) << ' ' << #c << " = " << (c) << ' ' << #d << " = " << (d) << ' ' << #e << " = " << (e) << '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

void init() {
	//std::iostream::sync_with_stdio(0);
	cout << std::fixed << std::setprecision(10);
	cerr << std::fixed << std::setprecision(10);
	srand(time(0));
}

const int MAXN = 1000;
int arr[MAXN][MAXN];

int main() {
    clock_t start = clock();
	init();

    int n, w, k;
    scanf("%d%d%d", &n, &w, &k);

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) arr[i][j] = 1;
    }
    while (clock() - start < 1.95 * CLOCKS_PER_SEC) {
        for (int i = 0; i < 100; ++i) {
            int a = rand() % n, b = rand() % n;
            std::swap(arr[a][b], arr[b][a]);
        }
        int win = 0;
        for (int i = 0; i < n; ++i) {
            int cur = 0;
            for (int j = 0; j < n; ++j)
                cur += arr[i][j];
            win += (cur >= w);
        }
        if (win == k) {
            cout << "YES\n";
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j)
                    cout << arr[i][j];
                cout << '\n';
            }
            return 0;
        }
    }

    cout << "NO\n";


	return 0;
}


