#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <utility>
#include <iomanip>
#include <iterator>
#include <queue>
#include <deque>
#include <set>
#include <map>

using namespace std;

#define pb push_back
#define mp make_pair
#define F first
#define S second

const int N = 300500;

int pos, neg;
int fb[N], fc[N];
pair< int, int> a[N], b[N], c[N];

int getN(int val) {
	int l = 1;
	int r = neg + 1;
	while (r - l > 1) {
		int m = (l + r) >> 1;
		if (c[m].F >= val) {
			l = m;
		} else r = m;
	}
	return l;
}

int getP(int val) {
	int l = 1;
	int r = pos + 1;
	while (r - l > 1) {
		int m = (l + r) >> 1;
		if (b[m].F <= val) {
			l = m;
		} else r = m;
	}
	return l;
}

bool can(int mid) {
	set< int > now;
	set< int > :: iterator it;
	for (int i = 1; i <= pos; i++) {
		int curX = b[i].F;
		while (true) {
			if (now.size() == 0) break;
			it = now.begin();
			if (*it < curX) {
				now.erase(it);
				continue;
			} else break;
		}
		now.insert(b[i].F + b[i].S);

		int iter = min(100, (int)now.size() - 1);
		vector<int> vv;
		while (iter--) {
		it = now.begin();
		int maxGo = *it - b[i].F;
		maxGo = -maxGo;
		if ((int)now.size() >= mid) return true;
		int idx = getN(maxGo);
		int add = fc[idx];
		if (c[idx].F < maxGo) add = 0; 
		if ((int)now.size() + add >= mid) return true;
		vv.pb(*it);
		now.erase(it);
		}	
		for (int j = 0; j < (int)vv.size(); j++) now.insert(vv[j]);
	}
	now.clear();
	for (int i = 1; i <= neg; i++) {
		int curX = c[i].F;
		while (true) {
			if (now.size() == 0) break;
			it = now.end(); --it;
			if (*it > curX) {
				now.erase(it);
				continue;
			} else break; 
		}
		now.insert(c[i].F - c[i].S);
		vector<int> vv;
		int iter = min(100, (int)now.size() - 1);
		iter = max(iter, 0);
		while (iter--) {             		
		it = now.end(); --it;
		int maxGo = *it - c[i].F;
		maxGo = -maxGo;
		if ((int)now.size() >= mid) return true;
		int idx = getP(maxGo);
		int add = fb[idx];
		if (b[idx].F > maxGo) add = 0;
		if ((int)now.size() + add >= mid) return true;
		vv.pb(*it);
		now.erase(it);
		}    
		for (int j = 0; j < (int)vv.size(); j++) now.insert(vv[j]);
	}	
	return false;
		
}

int main() {
//  freopen("input.txt","r",stdin);
 	//freopen("output.txt","w",stdout);
  int n;
  int xx, tt;
  scanf("%d", &n);
  int sz = 0;    
  vector<int> v;
  for (int i = 1; i <= n; i++) {
		scanf("%d%d", &xx, &tt);
		tt--;
		if (abs(xx) > tt) {
			continue;
		}
		tt = (tt - xx) / 2;
		++sz;
		a[sz] = mp(xx, tt);
		v.pb(tt);
	}
	sort(v.begin(), v.end());
	v.erase(unique(v.begin(), v.end()), v.end());
	sort(a + 1, a + 1 + sz);
	pos = 0;
	neg = 0;
	for (int i = 1; i <= sz; i++) {
		if (a[i].F >= 0) {
			b[++pos] = a[i];
		} else {
			c[++neg] = a[i];
		}
	}
	fc[neg + 1] = 0;
	fb[pos + 1] = 0;
	reverse(c + 1, c + 1 + neg);
	set< int > now;
	set< int > :: iterator it;
	for (int i = 1; i <= neg; i++) {
		int curX = c[i].F;
		while (true) {
			if (now.size() == 0) break;
			it = now.end(); --it;
			if (*it > curX) {
				now.erase(it);
				continue;
			} else break; 
		}
		now.insert(c[i].F - c[i].S);
		fc[i] = (int)now.size();
		fc[i] = max(fc[i], fc[i - 1]);
	}	
	now.clear();
	for (int i = 1; i <= pos; i++) {
		int curX = b[i].F;
		while (true) {
			if (now.size() == 0) break;
			it = now.begin();
			if (*it < curX) {
				now.erase(it);
				continue;
			} else break;
		}
		now.insert(b[i].F + b[i].S);
		fb[i] = (int)now.size();
		fb[i] = max(fb[i], fb[i - 1]);
	}
	int le = 0;
	int ri = n + 1;
	while (ri - le > 1) {
		int mid = (le + ri) >> 1;
		if (can(mid)) {
			le = mid;
		} else ri = mid;
	}
	if (le % 2 == 0 && le > 0) {
		--le;
	}          
	printf("%d\n", le);                    
	return 0;
}