#include <iostream>
#include <cstdlib>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <array>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = (1 << 29) + 5;
const ll LLINF = (1ll << 59) + 7;
const int MOD = 1000*1000*1000 + 7;

int n, m, k;
string st1, st2;

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    cin >> n >> m >> k;
    cin >> st1 >> st2;

    int answer = 0;
    string new_st;
    int cur = 0;
    for (int i = 0; i < m - n + 1; ++i)
    {
        new_st = st2.substr(i, n);
        int cnt = 0;
        for (int j = 0; j < n; ++j)
        {
            if (new_st[j] != st1[j])
            {
                ++cnt;
            }
        }

        if (cnt > k)
        {
            continue;
        }

        cur = 0;
        for (int j = 0; j < m - n + 1; ++j)
        {
            if (new_st == st2.substr(j, n))
            {
                ++cur;
            }
        }
        answer = max(answer, cur);
    }

    cout << answer;

    fclose(stdin);
    fclose(stdout);

    return 0;
}
