#include <iostream>
#include <cstdlib>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <array>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = (1 << 29) + 5;
const ll LLINF = (1ll << 59) + 7;
const int MOD = 1000*1000*1000 + 7;
const int MAX_N = 1000*1000 + 5;

int n, k;
int arr[MAX_N];
ll answer[MAX_N];
bool gg[MAX_N];

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    memset(gg, 0, sizeof(gg));

    scanf("%d %d", &n, &k);
    for (int i = 0; i < k; ++i)
    {
        scanf("%d", &arr[i]);
        gg[arr[i]] = true;
    }

    if (arr[0] == 1)
    {
        cout << 1000000 << " ";
        for (int i = 0; i < n - 1; ++i)
        {
            printf("%d ", 0);
        }
    }
    else
    {
        ll cnt_bad = 0;
        ll cnt_good = 0;
        ll ans1 = 0, ans2 = 1, ans = 1;
        for (int i = 1; i <= n; ++i)
        {
            if (gg[i])
            {
                ++cnt_bad;
            }
            else
            {
                ++cnt_good;
            }
            if (cnt_bad*ans2 > ans1*cnt_good)
            {
                ans = i;
                ans1 =cnt_bad;
                ans2 = cnt_good;
            }
        }

        for (int i = 1; i <= ans; ++i)
        {
            printf("%d ", 1);
        }
        for (int i = ans + 1; i <=n; ++i)
        {
            printf("%d ", 0);
        }
    }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
