#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <iostream>
#include <iostream>
#include <queue>
#include <deque>
#include <stack>
#include <iomanip>

using namespace std;

#define LOCAL 0
#define ll long long
#define mp make_pair
#define pb push_back
#define ppb pop_back

const int INF = (int)1e9;

int od(const string &s1, const string &s2)
{
	int res = 0;
	for (int i = 0; i < (int)s1.size(); ++i)
		if (s1[i] != s2[i])
			res++;
	return res;
}


int main()
{
#if LOCAL == 1
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif
	
	int n, m, k;
	cin >> n >> m >> k;
	
	string s1, s2;
	cin >> s1 >> s2;

	map <string, int> c;

	for (int i = 0; i < m; ++i)
	{
		int j = i + n;
		if (j > s2.size())
			break;
		c[s2.substr(i, n)]++;
	}
			
	map <string, int> :: iterator it;
	int ans = 0;
	for (it = c.begin(); it != c.end(); ++it)
	{
		//cout << it->first << "\n";
		if (it->second <= ans)
			continue;
		if (od(it->first, s1) <= k)
			ans = it->second;
	}

	cout << ans;

	return 0;
}


//#define TREAP
#ifdef TREAP

int get_rand()
{
	return rand() ^ (rand() << 15);
}

struct node
{
	int x;

	int y;

	node* left;
	
	node* right;

	node()
	{
	}

	node(int _x, int _y)
		: x(_x)
		, y(_y)
		, left(NULL)
		, right(NULL)
	{
	}
};

typedef node* p_node;

p_node merge(p_node L, p_node R)
{
	if (L == NULL)
		return R;
	if (R == NULL)
		return L;
	if (L->y > R->y)
	{
		L->right = merge(L->right, R);
		return L;
	}
	else
	{
		R->left = merge(L, R->left);
		return R;
	}
}

// [)

pair <p_node, p_node> split(p_node v, int key)
{
	if (v == NULL)
		return mp((p_node)NULL, (p_node)NULL);

	pair <p_node, p_node> tmp;
	if (v->x >= key)
	{
		tmp = split(v->left, key);
		v->left = tmp.second;
		tmp.second = v;
	}
	else
	{
		tmp = split(v->right, key);
		v->right = tmp.first;
		tmp.first = v;
	}

	return tmp;
}

void print(p_node v)
{
	if (v == NULL)
		return;
	print(v->left);
	cout << v->x << ' ';
	print(v->right);
}

void print_tree(p_node v)
{
	print(v);
	cout << "\n";
}

p_node find(p_node v, int key)
{
	if (v == NULL || v->x == key)
		return v;
	if (v->x > key)
		return find(v->left, key);
	else
		return find(v->right, key);
}

int main()
{
#if LOCAL == 1
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#endif

	p_node root = NULL;

	for (int i = 1; i <= 10; ++i)
	{
		p_node tmp = new node(i, get_rand());
		root = merge(root, tmp);
		print_tree(root);
	}

	print_tree(root);

	p_node v;

	for (int i = 1; i <= 10; ++i)
	{
		p_node v = find(root, i);
		if (v != NULL)
			cout << v->x << "\n";
	}

	pair <p_node, p_node> tmp = split(root, 6);
	print_tree(tmp.first);
	print_tree(tmp.second);

	return 0;
}

#endif