#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <stdio.h>
#include <cmath>
#include <list>
#include <iterator>
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 1e5;
const int INF = 1e9;

string st;
int d[SZ];

void zFunction() {
	d[0] = 0;
	int l = 0, r = 0;
	for (int i = 1; i < st.length(); i++) {
		if (r < i)
			d[i] = 0;
		else
			d[i] = min(r - i + 1, d[i - l]);
		while (i + d[i] < st.length() && st[d[i]] == st[i + d[i]])
			d[i]++;
		if (r < i + d[i] - 1)
			l = i, r = i + d[i] - 1;
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cout.precision(20);

	int n, m, k;
	cin >> n >> m >> k;
	string s, t;
	cin >> s >> t;

	int ans = 0;
	for (int i = 0; i < t.length() - s.length(); i++) {
		st = ""; int c = 0;
		for (int j = 0; j < s.length(); j++)
			if (t[i + j] == s[j])
				st += s[j];
			else
				c++, st += t[i + j];
		if (c <= k) {
			st = st + '#' + t;
			zFunction();
			int tans = 0;
			for (int j = s.length() + 1; j < st.length(); j++)
				if (d[j] == s.length())
					tans++;
			ans = max(ans, tans);
		}
	}

	cout << ans;
	
	return 0;
}