#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <map>
#include <string>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

struct item{
	int x, t;
	item(){}
};

bool operator < (const item l, const item r){
	if (abs(l.x) != abs(r.x)) return abs(l.x) < abs(r.x);
	return l.t > r.t;
}

void solve2(int n, int w, int k){
	vector<int> wins(n);
	vector<vector<int> > matr(n, vector<int>(n));
	int winners = 0;
	int i = 0;
	for (; i<k; i++){		
		int cnt = 0;
		for (int j = i+1; j<n; j++){
			cnt++;
			wins[i]++;
			matr[i][j] = 1;
		}
		if (cnt < w){				
			for (int j = i+1; j<n; j++){			
				wins[i]--;
				matr[i][j] = 0;
			}
			break;
		}
		winners++;
	}
	for (; i<n; i++){
		int j= i+1;
		for (int q = 0; q < w-1; q++){
			if (j >= n) break;
			wins[i]++;
			matr[i][j] = 1;
			j++;
		}
		for (;j < n; j++){
			wins[j]++;
			matr[j][i] = 1;
		}
	}
	int end_cnt = 0;
	for (int i=0; i<n; i++){
		if (wins[i] >= w) end_cnt++;
	}
	if (end_cnt != k){
		cout<<"NO";
		exit(0);
	}
	cout<<"YES\n";
	for (int i=0; i<n; i++){
		for (int j=0; j<n; j++){
			cout<<matr[i][j];
		}
		cout<<endl;
	}
	exit(0);
}

int main(){
	//freopen("in.txt", "rt", stdin);
	//freopen("ou.txt", "wt", stdout);
	int n, w, k;
	scanf("%d %d %d", &n, &w, &k);
	vector<int> wins(n);
	vector<vector<int> > matr(n, vector<int>(n));
	int winners = 0;
	int i = 0;
	for (; i<n; i++){		
		int cnt = 0;		
		int j = i+1;
		if (n-i-1 >= w){
			for (; j<n; j++){
				if (cnt == w) break;
				cnt++;
				wins[i]++;
				matr[i][j] = 1;
			}
			winners++;
		}		
		for(; j<n; j++){
			if (winners == k){				
				wins[i]++;
				matr[i][j] = 1;
			} else {
				//if (matr[i][j] == 1) continue;
				wins[j]++;
				matr[j][i] = 1;
				if (wins[j] == w) winners++;
			}
		}
	}
	int end_cnt = 0;
	for (int i=0; i<n; i++){
		if (wins[i] >= w) end_cnt++;
	}
	if (end_cnt != k){
		solve2(n, w, k);
	}
	for (int i=0; i<n; i++){
		for (int j=0; j<n; j++){
			//cout<<matr[i][j];
			if (i == j) continue;
			if (matr[i][j] == matr[j][i]) throw 1;
		}
		//cout<<endl;
	}
	cout<<"YES\n";
	for (int i=0; i<n; i++){
		for (int j=0; j<n; j++){
			cout<<matr[i][j];
		}
		cout<<endl;
	}
	
}