#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const int BIG = 1000000000;

int main()
{
    int n, k, i, j;
    cin >> n >> k;
    vector <int> problem(n);
    for(i = 0; i < n; i++)
        cin >> problem[i];

    //go go
    int ans = BIG;
    for(i = 0; i < n - k + 2; i++)
    {
        int level = 1;
        j = i;
        int leftproblem = 1;
        while(j < n and level < k)
        {
            leftproblem -= problem[j];
            if(leftproblem <= 0)
            {
                level++;
                leftproblem = level;
            }
            j++;
        }
        if(level == k and (j - i) < ans)
            ans = (j - i);
    }

    //ans
    if(ans == BIG)
        cout << -1;
    else
        cout << ans;
    return 0;
}
