#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const int BIG = 1000000000;

bool convertable(string one, string two, int k)
{
    int dif = 0;
    for(int i = 0; i < one.size(); i++)
    {
        if(one[i] != two[i])
            dif++;
    }
    if(dif <= k)
        return true;
    else
        return false;
}

int main()
{
    int n, m, k, i, j;
    cin >> n >> m >> k;
    string s, t, tmp;
    cin >> s >> t;
    map <string, int> subst;
    for(i = 0; i <= m - n; i++)
    {
        tmp = "";
        for(j = i; j < i + n; j++)
            tmp += t[j];
        if(subst.count(tmp) == 0)
            subst[tmp] = 1;
        else
            subst[tmp]++;
    }

    int ans = 0;
    for(auto it: subst)
    {
        if(convertable(s, it.first, k))
            ans = max(ans, it.second);
    }
    cout << ans;
    return 0;
}
