#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const int BIG = 1000000000;

bool comp_drob(long long a1, long long b1, long long a2, long long b2)
{
    long long left = a1 * b2;
    long long right = b1 * a2;
    return left > right;
}

int main()
{
    int n, k, i, j;
    cin >> n >> k;
    vector <int> friends(k);
    for(i = 0; i < k; i++)
        cin >> friends[i];

    //go go
    int lastdif = friends[0];
    int opta = 1, optb = friends[0];
    int optind = 0;
    for(i = 1; i < k; i++)
    {
        int nowa = i + 1;
        int nowb = friends[i];
        if(comp_drob(nowa, nowb, opta, optb))
        {
            //cout << "boo";
            opta = nowa;
            optb = nowb;
            optind = i;
        }
    }

    for(i = 0; i < n; i++)
    {
        if(i < friends[optind])
            cout << 1 << " ";
        else
            cout << 0 << " ";
    }
    return 0;
}
