#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const long long BIG = 1000000000;

vector < pair <long long, long long> > otr, pol;

long long getans(long long otr_cor, long long pol_cor)
{
    //kostylyat
    /*if(otr_cor >= otr.size() or pol_cor >= pol.size())
        return 0;*/
    if(otr_cor >= otr.size())
        otr_cor = (long long)otr.size() - 1;
    if(pol_cor >= pol.size())
        pol_cor = (long long)pol.size() - 1;

    long long first = 0, second = 0;
    long long otrgo = (otr.size() == 0) ? 0 : otr[otr_cor].first;
    long long polgo = (pol.size() == 0) ? 0 : pol[pol_cor].first;
    for(long long i = 0; i <= min(pol_cor, (long long)pol.size() - 1); i++)
    {
        if(pol[i].second > pol[i].first + 2 * otrgo or (pol[i].first == 0 and pol[i].second != 0))
            first++;
        if(pol[i].second > pol[i].first || (pol[i].first == 0 && pol[i].second != 0))
            second++;
    }
    for(long long i = 0; i <= min(otr_cor, (long long)otr.size() - 1); i++)
    {
        if(otr[i].second > otr[i].first + 2 * polgo)
            second++;
        if(otr[i].second > otr[i].first)
            first++;
    }
    //cout << "hehe " << first << " " << second << endl;
    return max(first, second);
}

long long getans2(long long otr_cor)
{
    long long l = 0;
    long long r = pol.size() - 1;
    while(l < r - 2)
    {
        long long m1 = (2 * l + r) / 3;
        long long m2 = (l + 2 * r) / 3;
        if(getans(otr_cor, m1) < getans(otr_cor, m2))
            l = m1;
        else
            r = m2;
    }
    //cout << max(max(getans(otr_cor, l), getans(otr_cor, l + 1)), getans(otr_cor, r)) << " boo\n";
    return max(max(getans(otr_cor, l), getans(otr_cor, l + 1)), getans(otr_cor, r));
}

int main()
{
    long long n, i;
    cin >> n;
    long long tmpx, tmpt;
    for(i = 0; i < n; i++)
    {
        cin >> tmpx >> tmpt;
        if(tmpx < 0)
            otr.push_back({-tmpx, tmpt});
        else
            pol.push_back({tmpx, tmpt});
    }
    sort(otr.begin(), otr.end());
    sort(pol.begin(), pol.end());

    //ternar
    long long l = 0;
    long long r = otr.size() - 1;
    while(l < r - 2)
    {
        long long m1 = (2 * l + r) / 3;
        long long m2 = (l + 2 * r) / 3;
        if(getans2(m1) < getans2(m2))
            l = m1;
        else
            r = m2;
    }

    long long answer = max(max(getans2(l), getans2(l + 1)), getans2(r));

    if(answer != 0 and answer % 2 == 0)
        cout << answer - 1;
    else
        cout << answer;
    return 0;
}
