import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;

public class First {
	private static class Pair implements Comparable<Pair> {
		final private int b;
		final private String a;

		public Pair(String a, int b) {
			this.a = a;
			this.b = b;
		}

		@Override
		public int compareTo(Pair o) {
			return o.b - this.b;
		}
	}

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		PrintWriter out = new PrintWriter(System.out);
		int n = in.nextInt();
		int m = in.nextInt();
		int k = in.nextInt();
		String s = in.next();
		String t = in.next();
		LinkedList<Pair> ar = new LinkedList<>();
		for (int i = 0; i < m - n + 1; i++) {
			String now = t.substring(i, i + n);
			int cnt = 0;
			for (int j = 0; j < m - n + 1; j++) {
				if (t.substring(j, j + n).equals(now)) {
					cnt++;
				}
			}
			ar.add(new Pair(now, cnt));
		}
		Pair[] arr = new Pair[ar.size()];
		for (int i = 0; i < ar.size(); i++) {
			arr[i] = ar.get(i);
		}
		Arrays.sort(arr);
		int ans = -1;
		for (int i = 0; i < arr.length; i++) {
			String chek = arr[i].a;
			int raz = 0;
			for (int j = 0; j < n; j++) {
				if (s.charAt(j) != chek.charAt(j)) {
					raz++;
				}
			}
			if (raz <= k) {
				ans = arr[i].b;
				break;
			}
		}
		out.print(ans);
		in.close();
		out.flush();
		out.close();
	}

}
