#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

template<class T, class U>
inline ostream &operator<<(ostream &out, const pair<T, U> &p)
{
    out << p.first << ' ' << p.second;
    return out;
}

template<class T, class U>
inline istream &operator<<(istream &in, const pair<T, U> &p)
{
    in >> p.first >> p.second;
    return in;
}

template<class T>
inline istream &operator>>(istream &in, vector<T> &v)
{
    for(auto &i : v)
        in >> i;
    return in;
}

template<class T>
inline ostream &operator>>(ostream &out, const vector<T> &v)
{
    if(v.empty())
        return out;

    out << v.front();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

void _pre()
{
#ifdef ANDREIKKAA
    assert(freopen("input.txt", "r", stdin) != nullptr);
    //freopen("output.txt", "w", stdout);
#endif // ANDREIKKA
}

void _post()
{
#ifdef ANDREIKKAA

#endif // ANDREIKKAA
}

void _solve()
{
    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    cin >> a;
    int ans = 228228;
    for(int i = 0; i < n; ++i)
    {
        int lvl = 1;
        int sum = 0;
        int j;
        for(j = i; j < n; ++j)
        {
            sum += a[j];
            if(sum >= lvl)
            {
                sum = 0;
                ++lvl;
            }
            if(lvl == k)
            {
                break;
            }
        }
        if(j < n)
            ans = min(ans, j - i + 1);
    }
    if(ans == 228228)
        ans = -1;
    cout << ans << endl;
}

int main()
{
    _pre();
    _solve();
    _post();
    return 0;
}
