#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

template<class T, class U>
inline ostream &operator<<(ostream &out, const pair<T, U> &p)
{
    out << p.first << ' ' << p.second;
    return out;
}

template<class T, class U>
inline istream &operator<<(istream &in, const pair<T, U> &p)
{
    in >> p.first >> p.second;
    return in;
}

template<class T>
inline istream &operator>>(istream &in, vector<T> &v)
{
    for(auto &i : v)
        in >> i;
    return in;
}

template<class T>
inline ostream &operator>>(ostream &out, const vector<T> &v)
{
    if(v.empty())
        return out;

    out << v.front();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

void _pre()
{
#ifdef ANDREIKKAA
    assert(freopen("input.txt", "r", stdin) != nullptr);
    //freopen("output.txt", "w", stdout);
#endif // ANDREIKKA
}

void _post()
{
#ifdef ANDREIKKAA

#endif // ANDREIKKAA
}

bool cmp(const pair<pair<int, int>, int> &a, const pair<pair<int, int>, int> &b)
{
    return a.first.first * 1LL * b.first.second < a.first.second * 1LL * b.first.first;
}

void _solve()
{
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    cin >> v;
    vector<bool> w(n);
    for(int i : v)
        w[i - 1] = true;
    int cnt = 0;
    vector<pair<pair<int, int>, int>> p;
    p.reserve(n);
    for(int i = 0; i < n; ++i)
    {
        cnt += w[i];
        p.push_back({{cnt, i + 1}, i + 1});
    }
    auto m = *max_element(p.begin(), p.end(), cmp);
    for(int i = 0; i < m.second; ++i)
        cout << "1 ";
    for(int i = m.second; i < n; ++i)
        cout << "0 ";
    cout << endl;
}

int main()
{
    _pre();
    _solve();
    _post();
    return 0;
}
