#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <utility>
#include <set>
#include <vector>
#include <bitset>
#include <cstdlib>

using namespace std;

long long n = 0, h = 0, a[1000002];

int main()
{
    cin >> n >> h;
    long long m = 0;
    for(int i = 1; i < n; i++){
        cin >> a[i];
        m = max(m, a[i]);
    }
    if(h >= n){
        for(int i = 1; i < n; i++){
            cout << "0 ";
        }
        return 0;
    }
    if(m < n){
        for(int i = 1; i < n; i++){
            cout << "-1 ";
        }
        return 0;
    }
    a[0] = h;
    int c = 0;
    vector<int> v;
    v.push_back(0);
    for(int i = 0; i < n && a[c] < n;){
        int m = a[c], f = 0;
        for(; i <= a[c]; i++){
            if(a[i] > m) m = a[i], f = i;
        }
        if(m == a[c]){
            for(int i = 1; i < n; i++){
                cout << "-1 ";
            }
            return 0;
        }
        else{
            v.push_back(f);
            c = f;
        }
    }
    for(int t = 1; t < n; t++){
        int x = lower_bound(v.begin(), v.end(), t) - v.begin();
        if(v[x] != t) cout << v.size() - 1 << " ";
        else{
            int q = a[t];
            a[t] = 1;
            int start = v[x - 1], finish;
            if(x == v.size() - 1) finish = n; else finish = v[x + 1];
            int p = 0, c = start;
            for(int i = start; i < finish && a[c] < finish;){
                int m = a[c], f = 0;
                for(; i <= a[c]; i++){
                    if(a[i] > m) m = a[i], f = i;
                }
                if(m == a[c]){
                    p = -1;
                    break;
                }
                else{
                    p++;
                    c = f;
                }
            }
            if(p == -1) cout << "-1 "; else cout << v.size() - 2 + p << " ";
        }
    }
    return 0;
}
