#include <iostream>
#include <cstdlib>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <array>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = (1 << 29) + 5;
const ll LLINF = (1ll << 59) + 7;
const int MOD = 1000*1000*1000 + 7;
const int MAX_N = 505;

int n, k;
int arr[MAX_N];

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    scanf("%d %d", &n, &k);

    for (int i = 0 ; i < n; ++i)
    {
        scanf("%d", &arr[i]);
    }

    int level = 1;
    int now;
    int answer = INF;
    for (int i = 0; i < n; ++i)
    {
        level = 1;
        now = 0;
        for (int j = i; j < n; ++j)
        {
            now += arr[j];
            if (now >= level)
            {
                now = 0;
                ++level;
            }
            //cout << i << " " <<now << " "<< level << endl;
            if (level == k)
            {
                answer = min(answer, j - i + 1);
                break;
            }
        }
    }

    if (answer == INF)
    {
        cout << -1;
    }
    else
    {
        cout << answer;
    }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
