#include <iostream>
#include <cstdlib>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <vector>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <array>
#include <algorithm>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = (1 << 29) + 5;
const ll LLINF = (1ll << 59) + 7;
const int MOD = 1000*1000*1000 + 7;
const int MAX_N = 1005;

int n, w, k;
int answer[MAX_N][MAX_N];
int poss[MAX_N];
int arr[MAX_N];
vector<pair<int, int> > gg;
set<pair<int, int> > wins;

bool cmp1(int a, int b)
{
    return poss[a] < poss[b] || (poss[a] == poss[b] && b > a);
}

bool cmp2(int a, int b)
{
    return poss[a] > poss[b] || (poss[a] == poss[b] && b > a);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    scanf("%d %d %d", &n, &w, &k);
    memset(answer, 0, sizeof(answer));

    for (int i = 0; i < n; ++i)
    {
        poss[i] = n;
        arr[i] = i;
        answer[i][i] = -1;
    }

    int cnt;
    for (int i = 0; i < k; ++i)
    {
        cnt = 0;
        //sort(arr, arr + n, cmp1);
        for (int j = n - 1; j > k - 1; --j)
        {
            if (answer[i][j] == 0)
            {
                answer[i][j] = 1;
                answer[j][i] = -1;
                ++cnt;
            }
        }

        if (cnt < w)
        {
            for (int j = 0; j < k; ++j)
            {
                if (answer[i][j] == 0)
                {
                    answer[i][j] = 1;
                    answer[j][i] = -1;
                    ++cnt;
                }
                if (cnt == w)
                {
                    break;
                }
            }
        }

        if (cnt < w)
        {
            printf("NO");
            return 0;
        }
    }

    for (int i = 0; i < k; ++i)
    {
        for (int j = 0; j < k; ++j)
        {
            if (answer[i][j] == 0)
            {
                answer[i][j] = 1;
                answer[j][i] = -1;
            }
        }
    }

    for (int i = k; i < n; ++i)
    {
        cnt = 0;
        for (int j = 0; j < n; ++j)
        {
            cnt += ((answer[i][j] == 0) ? 1:0);
        }
        gg.push_back(make_pair(0, i));
    }



    sort(gg.begin(), gg.end());

    for (int i = (int)gg.size() - 1; i > -1; --i)
    {
        cnt = 0;
        for (int j = (int)gg.size() - 1; j > -1; --j)
        {
            if (answer[gg[i].second][gg[j].second] == 1)
            {
                ++cnt;
            }
        }

        if (cnt >= w)
        {
            printf("NO");
            return 0;
        }

        for (int j = (int)gg.size() - 1; j > -1; --j)
        {
            if (answer[gg[i].second][gg[j].second] == 0)
            {
                ++gg[i].first;
                answer[gg[i].second][gg[j].second] = 1;
                answer[gg[j].second][gg[i].second] = -1;
                ++cnt;
            }

            if (cnt == w - 1)
            {
                for (int k = j - 1; k > -1; --k)
                {
                    if (answer[gg[i].second][gg[k].second] == 0)
                    {
                        ++gg[i].second;
                        answer[gg[i].second][gg[k].second] = -1;
                        answer[gg[k].second][gg[i].second] = 1;
                        //++cnt;
                    }
                }
                break;
            }
        }
        sort(gg.begin(), gg.end());
    }


    printf("YES\n");
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            printf("%d", (answer[i][j] == 1) ? 1:0);
        }
        printf("\n");
    }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
