#include <iostream>
#include <sstream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstring>
#include <string.h>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>


using namespace std;


#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
const double Pi = acos(-1);
const int INF = 1000000000;


struct point{
    int x, y;
    point(){}
    point(int _x, int _y) {
        x = _x;
        y = _y;
    }
    point(point a, point b) {
        x = b.x - a.x;
        y = b.y - a.y;
    }
};


/*
struct node {
    int x, y, l, r;
    init(int _x) {
        x = _x;
        y = rand();
        l = 0;
        r = 0;
    }
};


node d[600001];


void split(int v, int x, int &l, int &r) {
    if (v == 0) {
        l = 0;
        r = 0;
        return;
    }
    if (d[v].x > x) {
        split(d[v].l, x, l, d[v].l);
        r = v;
    } else {
        split(d[v].r, x, d[v].r, r);
        l = v;
    }
}


int merge(int l, int r) {
    if (l == 0) {
        return r;
    }
    if (r == 0) {
        return l;
    }
    if (d[l].y > d[r].y) {
        d[l].r = merge(d[l].r, r);
        return l;
    } else {
        d[r].l = merge(l, d[r].l);
        return r;
    }
}
*/


int n, k;
int a[1001];


int main() {
    cin >> n >> k;
    int ans = INF;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        int sum = 0;
        int ur = 1;
        int l = -1;
        for (int j = i; j < n; j++) {
            if (ur == k) {
                l = j;
                break;
            }
            if (a[j] + sum >= ur) {
                ur++;
                sum = 0;
                continue;
            }
            sum += a[j];
        }
        if (l == -1 && ur == k) {
            l = n - 1;
        }
        if (l != -1) {
            ans = min(ans, l - i + 1);
        }
    }
    if (ans == INF) {
        cout << -1 << endl;
    } else {
        cout << ans << endl;
    }
    return 0;
}
