#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <stdio.h>
#include <cmath>
#include <list>
#include <iterator>
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 1e5;
const int INF = 1e9;

int a[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cout.precision(20);

	int n, k;
	cin >> n >> k;
	for (int i = 0; i < n; i++)
		cin >> a[i];

	int ans = INF;

	for (int i = 0; i < n; i++) {
		int done = 0, lv = 1, j;
		for (j = i; j < n; j++) {
			done += a[j];
			if (done >= lv) {
				lv++;
				done = 0;
			}
			if (lv == k)
				break;
		}
		if (lv == k)
			ans = min(ans, j - i + 1);
	}

	cout << (ans == INF ? -1 : ans);
	
	return 0;
}