#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <stdio.h>
#include <cmath>
#include <list>
#include <iterator>
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 2e6;
const int INF = 1e9;

pair<int, int> a[SZ];
vector<pair<int, int>> pos, neg;

map<int, int> po, ne;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cout.precision(20);

	int n;
	cin >> n;
	int pl = 0;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		if (x < 0)
			neg.push_back(make_pair(-x, y));
		else if (x > 0)
			pos.push_back(make_pair(x, y));
		else if (y)
			pl++;
	}

	sort(neg.begin(), neg.end());
	sort(pos.begin(), pos.end());

	int c1 = 0;
	for (int i = 0; i < pos.size(); i++)
		if (pos[i].first < pos[i].second) {
			c1++;
			ne[(pos[i].second - pos[i].first + 1) / 2]++;
			pos[i].second = c1;
		} else
			pos[i].second = c1;
	int c2 = 0;
	for (int i = 0; i < neg.size(); i++)
		if (neg[i].first < neg[i].second) {
			c2++;
			po[(neg[i].second - neg[i].first + 1) / 2]++;
			neg[i].second = c2;
		} else
			neg[i].second = c2;

	int ans = 0;
	for (int i = 0; i < pos.size(); i++) {
		while (po.size() && po.begin()->first <= pos[i].first) {
			c2 -= po.begin()->second;
			po.erase(po.begin());
		}
		ans = max(ans, pos[i].second + c2);
	}

	for (int i = 0; i < neg.size(); i++) {
		while (ne.size() && ne.begin()->first <= neg[i].first) {
			c1 -= ne.begin()->second;
			ne.erase(ne.begin());
		}
		ans = max(ans, neg[i].second + c1);
	}

	ans += pl;
	if (ans && ans % 2 == 0)
		ans--;
	cout << ans;

	return 0;
}