#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <stdio.h>
#include <cmath>
#include <list>
#include <iterator>
typedef long long ll;
typedef long double ld;
using namespace std;

const int SZ = 2e3;
const int INF = 1e9;

bool v[SZ][SZ];
int d[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cout.precision(20);

	int n, w, k;
	cin >> n >> w >> k;

	int c = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++)
			v[i][j] = true;
		d[i] = n - i - 1;
		if (d[i] >= w)
			c++;
	}

	if (c > k) {
		for (int i = k; i < c; i++)
			for (int j = c; j < n; j++)
				if (d[j] < w - 1 && d[i] >= w) {
					d[i]--;
					d[j]++;
					swap(v[i][j], v[j][i]);
				}
		c = 0;
		for (int i = 0; i < n; i++)
			if (d[i] >= w)
				c++;
		if (c != k)
			return 0 * printf("NO");

	} else if (c < k) {
		for (int i = c; i < k; i++)
			for (int j = 0; j < c; j++)
				if (d[j] > w && d[i] < w) {
					swap(v[i][j], v[j][i]);
					d[i]++;
					d[j]--;
				}
				c = 0;
		for (int i = 0; i < n; i++)
			if (d[i] >= w)
				c++;
		if (c != k)
			return 0 * printf("NO");
	}

	cout << "YES\n";
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++)
			cout << int(v[i][j]);
		cout << "\n";
	}

	return 0;
}