#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iostream>
#include <vector>
#include <cstring>
#include <numeric>
using namespace std;
struct flower
{
	int x;
	int t;
	flower(int _x,int _t)
	{
		x=_x;
		t=_t;
	}
	flower()
	{
		x=0;
		t=0;
	}
	int canMore()
	{
		if (t < x) return -10000;
		return (t - x)/2;
	}
};
bool cmpx(flower x, flower y)
{
	return x.x<y.x;
}
bool cmpMore(flower x, flower y)
{
	return x.canMore() > y.canMore();
}
int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n;
	scanf("%d", &n);
	vector<flower>pos,neg;
	for(int i=1;i<=n;i++)
	{
		int x,t;
		scanf("%d %d",&x,&t);
		t--;
		if(x>=0)
		{
			pos.push_back(flower(x,t));
		}
		else
		{
			neg.push_back(flower(-x,t));
		}
	}
	int ans=0;
	for(int it=1;it<=2;it++)
	{
		sort(pos.begin(),pos.end(), cmpMore);
		sort(neg.begin(),neg.end(), cmpx);
		int j = (int)neg.size() - 1;
		for(int i =0;i<(int)pos.size();i++)
		{
			if(pos[i].canMore() < 0) continue;			
			while(j>=0 && neg[j].x>pos[i].canMore())j--;
			ans=max(ans, i + 1 + j + 1);
		}
		swap(pos,neg);
	}
	if(ans%2==0 && ans!=0) ans--;
	printf("%d\n", ans);
}