#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <iostream>
#include <vector>
#include <cstring>
#include <numeric>
using namespace std;
int a[1007][1007];
int ans[1007][1007];
bool used[1007];
int arr[10007];
int arrsz=0;
void push(int x)
{
	arrsz++;
	arr[arrsz]=x;
}
int size()
{
	return arrsz;
}
void clear()
{
	arrsz=0;
}
void dfs(int v,int n,int rem)
{
	push(v);
	if(used[v]) return;
	used[v]=true;
	v+=rem;
	if(v>n) v-=n;
	dfs(v,n,rem);
}
void make(int n)
{
	for(int i=1;i<n;i++)
	{
		for(int j=1;j<=n;j++)
		{
			used[j]=false;
		}		
		for(int j=1;j<=n;j++)
		{
			if(!used[j])
			{
				clear();
				dfs(j, n, i);
				for(int k=1;k<size();k++)
				{
					int u=arr[k],v=arr[k+1];
					a[u][v]=1;
					a[v][u]=0;
				}
			}
		}
	}
}
int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n,w,k;
	scanf("%d %d%d",&n,&w,&k);
	make(k);
	for(int i=1;i<=k;i++)
	{
		for(int j=1;j<=k;j++)
		{
			ans[i][j]=a[i][j];
		}
	}
	make(n-k);
	for(int i=k+1;i<=n;i++)
	{
		for(int j=k+1;j<=n;j++)
		{
			ans[i][j]=a[i-k][j-k];
		}
	}
	for(int i=1;i<=k;i++)
	{
		for(int j=k+1;j<=n;j++)
		{
			ans[i][j]=1;
		}
	}
	int cnt=0;
	for(int i=1;i<=n;i++)
	{
		int cur=0;
		for(int j=1;j<=n;j++)
		{
			if(ans[i][j]==1) cur++;
		}
		if(cur>=w) cnt++;
	}
	if(cnt==k)
	{
		printf("YES\n");
		for(int i=1;i<=n;i++)
		{
			for(int j=1;j<=n;j++)
			{
				printf("%d", ans[i][j]);
			}
			printf("\n");
		}
	}
	else
	{
		printf("NO\n");
	}
	return 0;
}