#define _CRT_NO_WARNINGS
//#pragma comment(linker, "/STACK:1000000")

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <map>
#include <stack>
#include <deque>
#include <set>
#include <vector>
#include <algorithm>
#include <ctime>
#include <cmath>
#include <utility>
#include <iomanip>
#include <string>

using namespace std;

const int MAXN = 200000;
pair<int, int> a[MAXN + 1];
vector<pair<int, int> > pos;
int ans, n;

void solve() {
	sort(a, a + n);
	pos.clear();
	for(int i = 0; i < n; i++)
		if(a[i].first < 0)
			pos.push_back(make_pair(a[i].first, a[i].second > -a[i].first));
	for(int i = (int)pos.size() - 2; i >= 0; i--)
		pos[i].second += pos[i + 1].second;
	vector<int> calc;
	for(int i = 0; i < n; i++) {
		if(a[i].first >= 0) {
			calc.push_back(-(a[i].second - a[i].first - 1) / 2);
		}
	}
	sort(calc.begin(), calc.end());
	int cur = 0;
	for(int i = 0; i < (int)pos.size(); i++) {
		while(cur < (int)calc.size() && calc[cur] <= pos[i].first)
			cur++;
		ans = max(ans, pos[i].second + cur);
	}
}

int main() {
	//ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	cin >> n;
	for(int i = 0; i < n; i++) {
		scanf("%d%d", &a[i].first, &a[i].second);
	}
	solve();
	for(int i = 0; i < n; i++)
		a[i].first = -a[i].first;
	solve();
	if(ans % 2 == 0)
		ans = max(0, ans - 1);
	cout << ans << endl;
	return 0;
}