#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#define rep(i, n) for (decltype(n) i = 0; i < n; i++)
#define dep(i, n) for (decltype(n) i = n - 1; i >= 0; i--)
#define FOR(i, a, b) for (decltype(b) i = a; i <= b; i++)
#define FORD(i, a, b) for (decltype(a) i = a; i >= b; i--)
#define len(a) (int)a.size()
#define all(a) a.begin(), a.end()
typedef long double ld;
typedef long long int64;
template<class T>
T sqr(T a)
{
    return a * a;
}

using namespace std;
const int maxn = 1010;

set<pair<int, int> > c;
int d[maxn];
int s[maxn];
bool v[maxn][maxn];

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, w, k;
	cin >> n >> w >> k;
	if (k == 0)
	{
		assert(n < 5);
	}
    rep(i, n)
    {
        d[i] = n - 1;
        c.insert(make_pair(d[i], i));
    }
    int cnt = 0;
    while (!c.empty() && cnt < k)
    {
		auto x = c.lower_bound(make_pair(w, -1));
        if (x != c.end() && x->first >= w)
        {
            int am = 0;
            for (int i = 0; i < n && am < w; i++)
            {
                if (i != x->second && !v[i][x->second])
                {
                    v[x->second][i] = 1;
                    d[x->second]--;
                    c.erase(make_pair(d[i], i));
                    am++;
                    d[i]--;
                    c.insert(make_pair(d[i], i));
                }
            }
            c.erase(x);
			cnt++;
        }
        else
        {
            cout << "NO" << endl;
            return 0;
        }
    }
    if (cnt < k)
    {
        cout << "NO" << endl;
        return 0;
    }
    rep(i, n)
    {
        rep(j, n)
            s[i] += v[i][j];
    }
    rep(i, n)
    {
        FOR(j, i + 1, n - 1)
        {
            if (!v[i][j] && !v[j][i])
            {
                if (s[i] >= w)
                    s[i]++, v[i][j] = 1;
                else if (s[j] >= w)
                    s[j]++, v[j][i] = 1;
                else
                {
                    if (s[i] <= s[j])
                        s[i]++, v[i][j] = 1;
                    else
                        s[j]++, v[j][i] = 1;
                }
            }
        }
    }
    int curc = 0;
    rep(i, n)
    {
        if (s[i] >= w)
            curc++;
    }
    if (curc != k)
    {
        cout << "NO" << endl;
        return 0;
    }
    cout << "YES" << endl;
    rep(i, n)
    {
        rep(j, n)
            cout << v[i][j];
        cout << endl;
    }
	return 0;
}
