#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <map>
#include <string>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

struct item{
	int x, t;
	item(){}
};

bool operator < (const item l, const item r){
	if (abs(l.x) != abs(r.x)) return abs(l.x) < abs(r.x);
	return l.t > r.t;
}

int main(){
	//freopen("in.txt", "rt", stdin);
	//freopen("ou.txt", "wt", stdout);
	int n, w, k;
	scanf("%d %d %d", &n, &w, &k);
	vector<int> wins(n);
	vector<vector<int> > matr(n, vector<int>(n));
	int winners = 0;
	int i = 0;
	for (; i<k; i++){		
		int cnt = 0;
		for (int j = i+1; j<n; j++){
			cnt++;
			wins[i]++;
			matr[i][j] = 1;
		}
		if (cnt < w){				
			for (int j = i+1; j<n; j++){			
				wins[i]--;
				matr[i][j] = 0;
			}
			break;
		}
		winners++;
	}
	for (; i<n; i++){
		int j= i+1;
		for (int q = 0; q < w-1; q++){
			if (j >= n) break;
			wins[i]++;
			matr[i][j] = 1;
			j++;
		}
		for (;j < n; j++){
			wins[j]++;
			matr[j][i] = 1;
		}
	}
	int end_cnt = 0;
	for (int i=0; i<n; i++){
		if (wins[i] >= w) end_cnt++;
	}
	if (end_cnt != k) return cout<<"NO",0;
	cout<<"YES\n";
	for (int i=0; i<n; i++){
		for (int j=0; j<n; j++){
			cout<<matr[i][j];
		}
		cout<<endl;
	}
}