#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <bitset>
#include <queue>
#include <deque>
#include <set>
#include <cmath>
#include <memory.h>
#include <cstdlib>
#define mp make_pair
#define fs first
#define sc second
using namespace std;

typedef long long ll;	
typedef long double ld;

const int MAXN = 1000002;
const int INF = 2 * MAXN;
const int LG = 22;
int f1[MAXN], f2[MAXN];
int s2[MAXN];

int a[MAXN];
int h[MAXN];
int f[MAXN];
int rmq[4 * MAXN];

int an[MAXN];
int sf[MAXN][LG];
int sh[MAXN][LG];


int bst(int i1, int i2)
{
	if (h[i1] <= h[i2]) return i2;
	else return i1;
}

int n;
vector <int> ans;

bool go()
{
	ans.clear();
	int cur = 1;
	while (cur < n)
	{
		ans.push_back(cur);
		int nc = cur;
		for (int i = cur + 1; i <= h[cur]; i++)
		{
			if (h[i] > h[nc]) nc = i;
		}
		if (nc == cur) return false;
		cur = nc;
	}
	return true;
}

int get_h(int l, int r)
{
	if (r < l) return 0;
	int d = s2[r - l];
	return max(sh[l][d], sh[r - (1 << d) + 1][d]);
}

int get_f(int l, int r)
{
	if (r < l) return 2 * MAXN;
	int d = s2[r - l];
	return min(sf[l][d], sf[r - (1 << d) + 1][d]);
}

void build()
{
	f[n] = 0;
	sf[n][0] = 0;
	for (int i = n - 1; i >= 1; i--)
	{
		f[i] = get_f(i + 1, h[i]) + 1;
		sf[i][0] = f[i];
		for (int j = 1; i + (1 << j) <= (n + 1); j++)
		{
			sf[i][j] = min(sf[i][j - 1], sf[i + (1 << (j - 1))][j - 1]);
		}
	}
	for (int i = 1; i <= n; i++) sh[i][0] = h[i];
	for (int i = 0; i  < LG; i++)
	{
		for (int j = 0; j + (1 << (i + 1)) <= (n + 1); j++)
		{
			sh[j][i + 1] = max(sh[j][i], sh[j + (1 << i)][i]);
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(0);
	int hk;	
	cin>> n >> hk;
	hk = min(hk, n);
	s2[0] = 0;
	for (int i = 1; i < MAXN; i++)
	{
		s2[i] =	s2[i - 1];	
		if  ((1 << (s2[i] + 1)) <= (i + 1)) s2[i]++;
	}
	for (int i = 1; i < n; i++)
	{
		cin >> h[i];
		h[i] = min(h[i], n);
	}
	h[0] = 0;
	h[n] = n + 1;
	int d1 = h[1];
	h[1] = hk;
	if (go()) an[1] = ans.size() - 1;
	else an[1] = -1;
	h[1] = max(h[1], d1);
	if (!go())
	{
		for (int i = 1; i < n; i++) cout << "-1 ";
		cout << "\n";
		return 0;
	}
	build();
	for (int i = 2; i <= n; i++) an[i] = ans.size() - 1;
	for (int i = 1; i < ans.size(); i++)
	{
		int v = ans[i];
		int dh = h[ans[i - 1]];	
		int nv = 0;
		nv = max(get_h(ans[i - 1] + 1, v - 1), get_h(v + 1, dh));
		int gg = get_f(v + 1, nv);
		if (gg < n) an[v] = gg + i;
		else an[v] = -1;
	}
	for (int i = 1;	 i < n; i++) cout << an[i] << " ";
	cout << "\n";
	return 0;
}		