#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <bitset>
#include <queue>
#include <deque>
#include <set>
#include <cmath>
#include <memory.h>
#include <cstdlib>
#define mp make_pair
#define fs first
#define sc second
using namespace std;

typedef long long ll;	
typedef long double ld;

const int MAXN = 100002;

const ll INF = (1ll << 60);
int a[MAXN];
int a2[MAXN];
int c[MAXN];
int p1[MAXN], p2[MAXN];
int l[MAXN];
ll f[MAXN];
int p[MAXN];
int lca[MAXN];
int id[MAXN];
vector <int> lc[MAXN];
vector <int> b;

string st;
int s[MAXN];
vector <int> cr;
ll df[3];

int main()
{
	ios_base::sync_with_stdio(0);
	int n;
	ll d, w;
	cin >> n >> w >> d;
	cin >> st;
	for (int i = 0; i < n; i++)
	{
		if (st[i] == 'r') s[i] = 0;
		if (st[i] == 'p') s[i] = 1;
		if (st[i] == 's') s[i] = 2;
		c[i] = s[i];
		a[i] = i;
	}
	for (int j = 0; (1 << j) <= n; j++)
	{
		for (int i = 0; i < n; i++)
		{
			p1[i] = c[i];
			p2[i] = c[(i + (1 << j)) % n];
		}
		memset(p, 0, sizeof(p));
		for (int i = 0; i < n; i++)
		{
			p[p2[i]]++;
		}
		for (int i = 1; i < MAXN; i++) p[i] += p[i - 1];
		for (int i = n - 1; i >= 0; i--)
		{
			a2[--p[p2[i]]] = i;
		}
		memset(p, 0, sizeof(p));
		for (int i = 0; i < n; i++)
		{
			p[p1[a2[i]]]++;
		}
		for (int i = 1; i < MAXN; i++) p[i] += p[i - 1];
		for (int i = n - 1; i >= 0; i--)
		{
			a[--p[p1[a2[i]]]] = a2[i];
		}
		c[a[0]] = 0;
		for (int i = 1; i < n; i++)
		{
			c[a[i]] = c[a[i - 1]];
			if ((p1[a[i]] != p1[a[i - 1]]) || (p2[a[i]] != p2[a[i - 1]])) c[a[i]]++;
		}
	}
	for (int i = 0; i < n; i++) id[a[i]] = i;
	int cur = 0;
	for (int i = 0; i < n; i++)
	{
		cur = max(0, cur - 1);
		int ic = id[i];
		if (ic + 1 != n)
		{
			while ((cur < n) && (s[(i + cur) % n] == s[(a[ic + 1] + cur) % n])) cur++;	
			lca[ic] = cur;	
			lc[cur].push_back(ic);
		}
	}
	for (int i = 0; i < n; i++)
	{
		p2[i] = p1[i] = i;
		l[i] = n;
		f[i] = 0;
	}
	for (int i = n; i >= 0; i--)
	{
		int lv, rv;
		b = lc[i];
		int m = b.size();
		for (lv = 0; lv < m; lv = rv)
		{
			rv = lv + 1;
			while ((rv != m) && (p2[b[rv - 1] + 1] == b[rv])) rv++;
			cr.clear();
			cr.push_back(p1[b[lv]]);
			for (int j = lv; j < rv; j++)
			{
				cr.push_back(b[j] + 1);
			}
			int cs = cr.size();
			p2[cr[0]] = p2[cr[cs - 1]]; 
			p1[p2[cr[0]]] = cr[0];
			df[0] = df[1] = df[2] = INF;
			if (i != n)
			{
				for (int j = 0; j < cs; j++)
				{
					int sym = s[(a[cr[j]] + i) % n];
					df[sym] = f[cr[j]] + w * (ll)(l[cr[j]] - i - 1);
				}
				l[cr[0]] = i;
				f[cr[0]] = min(min(d + df[0], 0 + df[1]), w + df[2]);
				f[cr[0]] = max(f[cr[0]], min(min(d + df[1], 0 + df[2]), w + df[0]));
				f[cr[0]] = max(f[cr[0]], min(min(d + df[2], 0 + df[0]), w + df[1]));
			}
		}
	}
	f[0] += w * (ll)l[0];
	cout << f[0] << endl;
	return 0;
}	