#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const long long BIG = 1000000000;

vector < pair <long long, long long> > otr, pol, zero;

int main()
{
    long long n, i;
    cin >> n;
    long long tmpx, tmpt;
    long long zerocnt = 0;
    for(i = 0; i < n; i++)
    {
        cin >> tmpx >> tmpt;
        if(tmpx < 0)
            otr.push_back({-tmpx, tmpt});
        else if(tmpx > 0)
            pol.push_back({tmpx, tmpt});
        else if(tmpt != 0)
            zerocnt++;
    }
    sort(otr.begin(), otr.end());
    sort(pol.begin(), pol.end());

    long long optimal = 0;
    // getting answer
    vector <long long> pol_rest;
    for(i = 0; i < pol.size(); i++)
    {
        pol_rest.push_back(pol[i].second - pol[i].first);
    }
    sort(pol_rest.begin(), pol_rest.end());
    long long cnt = 0;
    optimal = max(optimal, (long long)(pol_rest.end() - upper_bound(pol_rest.begin(), pol_rest.end(), 0)));
    for(i = 0; i < otr.size(); i++)
    {
        if(otr[i].second > otr[i].first)
            cnt++;
        long long pol_add = pol_rest.end() - upper_bound(pol_rest.begin(), pol_rest.end(), 2 * otr[i].first);
        if(pol_add + cnt > optimal)
            optimal = pol_add + cnt;
    }
    //getting answer 2
    vector <long long> otr_rest;
    for(i = 0; i < otr.size(); i++)
    {
        otr_rest.push_back(otr[i].second - otr[i].first);
    }
    sort(otr_rest.begin(), otr_rest.end());
    cnt = 0;
    optimal = max(optimal, (long long)(otr_rest.end() - upper_bound(otr_rest.begin(), otr_rest.end(), 0)));
    for(i = 0; i < pol.size(); i++)
    {
        if(pol[i].second > pol[i].first)
            cnt++;
        long long otr_add = otr_rest.end() - upper_bound(otr_rest.begin(), otr_rest.end(), 2 * pol[i].first);
        if(otr_add + cnt > optimal)
            optimal = otr_add + cnt;
    }

    //putting
    long long answer = optimal + zerocnt;
    if(answer != 0 and answer % 2 == 0)
        answer--;
    cout << answer;
    return 0;
}
