#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>

using namespace std;

const long long BIG = 1000000000;

int main()
{
    int n, w, k, i, j;
    cin >> n >> w >> k;
    int table[n][n];
    vector <int> freegame(n, n - 1);
    vector <bool> stat(n, false);
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < n; j++)
        {
            if(i == j)
                table[i][j] = 0;
            else
                table[i][j] = -1;
        }
    }
    int ork = k;

    for(i = 0; i < n; i++)
    {
        if(k > 0)
        {
            if(freegame[i] >= w)
            {
                int rest = w;
                for(j = 0; j < n; j++)
                {
                    if(table[i][j] == -1 and rest > 0)
                    {
                        rest--;
                        table[i][j] = 1;
                        table[j][i] = 0;
                        freegame[j]--;
                        freegame[i]--;
                    }
                }
                stat[i] = true;
                k--;
            }
        }
    }

    if(k > 0)
        cout << "NO";
    else
    {
        int games = ((n - ork) * (n - ork - 1)) / 2;
        if(games > (n - ork) * (ork - 1))
        {
            cout << "NO";
            //cout << games;
        }
        else
        {
            cout << "YES" << endl;
            for(i = 0; i < n; i++)
            {
                if(stat[i])
                {
                    for(j = 0; j < n; j++)
                    {
                        if(table[i][j] == -1)
                        {
                            table[i][j] = 1;
                            table[j][i] = 0;
                        }
                    }
                }
                else
                {
                    int maxwin = w - 1;
                    for(j = 0; j < n; j++)
                    {
                        if(table[i][j] == -1 and maxwin > 0)
                        {
                            table[i][j] = 1;
                            table[j][i] = 0;
                            maxwin--;
                        }
                    }
                }
            }
            for(i = 0; i < n; i++)
            {
                for(j = 0; j < n; j++)
                    cout << table[i][j];
                cout << endl;
            }
            return 0;
        }
    }

}
